BeamAndGo.Member.Admin.Web/Pages/Admin/List.cshtml.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using BeamAndGo.Core.Common;
using BeamAndGo.Core.Data;
using BeamAndGo.Member.Admin;
using BeamAndGo.Member.Admin.Web.Filters;
using BeamAndGo.Member.Admin.Web.Models;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;

namespace BeamAndGo.Member.Admin.Web.Pages.Admin
{
    [LoginRequired]
    [ValidateAntiForgeryToken]
    public class AdminListModel : PageModel
    {
        private readonly ApplicationOptions _applicationOptions;
        private readonly ILogger<AdminListModel> _logger;
        private readonly IMemberAdminService _MemberAdminService;


        public IEnumerable<MemberAdmin> MemberAdmins { get; private set; }
        public string MinExpiryDate { get; set; }


        [BindProperty]
        public DateTimeOffset? ExpiryDate { get; set; }
        [BindProperty(SupportsGet = true)]
        public int CurrentPage { get; set; } = 1;
        [BindProperty(SupportsGet = true)]
        public int PagesCount { get; set; } = 1;
        [BindProperty]
        public MemberAdminAccessLevel AccessLevel { get; set; }
        [BindProperty]
        public string AdminMemberSid { get; set; }
        [BindProperty(SupportsGet = true)]
        public string CurrentSearch { get; set; } = string.Empty;
        [BindProperty]
        public RecordStatus AdminRecordStatus { get; set; }


        public AdminListModel(ILogger<AdminListModel> logger,
                              IMemberAdminService MemberAdminService,
                              IOptions<ApplicationOptions> applicationOptions)
        {
            _logger = logger;
            _MemberAdminService = MemberAdminService;
            _applicationOptions = applicationOptions.Value;
        }

        public async Task<IActionResult> OnGetAsync(string search = "", int start = 0)
        {
            try
            {
                var sid = HttpContext.Session.GetString(SessionKey.MemberSid);
                var admin = await _MemberAdminService.GetByMemberSid(sid);

                if (admin.AccessLevel == MemberAdminAccessLevel.SuperAdmin)
                {
                    int count = 0;
                    start = start > 1 ? start : 1;
                    var startPage = start > 0 ? ((start - 1) * _applicationOptions.PageSize) : 0;
                    MinExpiryDate = DateTime.Now.ToString("yyyy-MM-dd");

                    if (!string.IsNullOrEmpty(search))
                    {
                        var iAsyncMemberAdmin = _MemberAdminService.Search(search, startPage);
                        MemberAdmins = iAsyncMemberAdmin.ToEnumerable();
                        count = MemberAdmins.Count();
                    }
                    else
                    {
                        MemberAdmins = await _MemberAdminService.ListAll(startPage);
                        count = await _MemberAdminService.Count();
                    }

                    CurrentPage = start;
                    CurrentSearch = search;
                    PagesCount = ((count - 1) / _applicationOptions.PageSize) + 1;
                }
                else
                {
                    string currentPageForError = Request.Path.ToString().Replace("/", " ");
                    return RedirectToPage("/Error", new { error = ErrorMessage.AccessDenied.Error, error_description = ErrorMessage.AccessDenied.ErrorDescription, error_page = currentPageForError });
                }
            }
            catch (Exception ex)
            {
                if (ex is ArgumentException || ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return RedirectToPage("/Error", new { error = ExceptionExtensions.GetCode(ex), error_description = ExceptionExtensions.GetDescription(ex) });
                }
                else
                {
                    throw;
                }
            }

            return Page();
        }

        public async Task<IActionResult> OnPostRemoveAdmin()
        {
            try
            {
                await _MemberAdminService.Delete(AdminMemberSid);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully removed admin");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }

            return Redirect("~/Admin/List");
        }

        public async Task<IActionResult> OnPostUpdateAdmin()
        {
            try
            {
                var MemberAdmin = await _MemberAdminService.Update(AdminMemberSid, AccessLevel, ExpiryDate);

                if (AdminRecordStatus != MemberAdmin.RecordStatus)
                {
                    if (AdminRecordStatus == RecordStatus.Active)
                    {
                        var memberEnable = await _MemberAdminService.Enable(AdminMemberSid);
                    }
                    else
                    {
                        var memberDisable = await _MemberAdminService.Disable(AdminMemberSid);
                    }
                }

                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully updated admin");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }

            return Redirect("~/Admin/List");
        }
    }
}

BeamAndGo.Member.Admin.Web/Pages/PreferenceType/List.cshtml.cs
using System;
using System.Collections.Generic;
using System.Threading.Tasks;
using BeamAndGo.Core.Common;
using BeamAndGo.Core.Data;
using BeamAndGo.Member;
using BeamAndGo.Member.Admin;
using BeamAndGo.Member.Admin.Web.Filters;
using BeamAndGo.Member.Admin.Web.Models;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.RazorPages;
using Microsoft.Extensions.Logging;

namespace BeamAndGo.Member.Admin.Web.Pages.PreferenceType
{
    [ValidateAntiForgeryToken]
    [LoginRequired]
    public class PreferenceTypeListModel : PageModel
    {
        private readonly ILogger<PreferenceTypeListModel> _logger;
        private readonly IMemberAdminService _MemberAdminService;
        private readonly IMemberPreferenceTypeService _memberPreferenceTypeService;

        [BindProperty]
        public int PreferenceTypeID { get; set; }

        [BindProperty]
        public string PreferenceTypeName { get; set; }

        [BindProperty]
        public string PreferenceTypeDescription { get; set; }

        [BindProperty]
        public string PreferenceTypeDefaultValue { get; set; }

        [BindProperty]
        public RecordStatus PreferenceTypeStatus { get; set; }
        [BindProperty]
        public RecordStatus CurrentPreferenceTypeStatus { get; set; }
        public IEnumerable<MemberPreferenceType> MemberPreferenceTypes { get; private set; }

        public PreferenceTypeListModel(ILogger<PreferenceTypeListModel> logger, IMemberAdminService MemberAdminService, IMemberPreferenceTypeService memberPreferenceTypeService)
        {
            _logger = logger;
            _MemberAdminService = MemberAdminService;
            _memberPreferenceTypeService = memberPreferenceTypeService;
        }

        public async Task<IActionResult> OnGetAsync()
        {
            try
            {
                var sid = HttpContext.Session.GetString(SessionKey.MemberSid);
                var admin = await _MemberAdminService.GetByMemberSid(sid);

                if (admin.AccessLevel == MemberAdminAccessLevel.SuperAdmin)
                {
                    MemberPreferenceTypes = await _memberPreferenceTypeService.ListAll();
                }
                else
                {
                    string currentPageForError = Request.Path.ToString().Replace("/", " ");
                    return RedirectToPage("/Error", new { error = ErrorMessage.AccessDenied.Error, error_description = ErrorMessage.AccessDenied.ErrorDescription, error_page = currentPageForError });
                }
            }
            catch (Exception ex)
            {
                if (ex is ArgumentException || ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    return RedirectToPage("/Error", new { error = ExceptionExtensions.GetCode(ex), error_description = ExceptionExtensions.GetDescription(ex) });
                }
                else
                {
                    throw;
                }
            }

            return Page();
        }

        public async Task<IActionResult> OnPostCreatePreferenceType()
        {
            try
            {
                var adminMemberSid = HttpContext.Session.GetString(SessionKey.MemberSid);

                var MemberAdmin = await _memberPreferenceTypeService.Create(PreferenceTypeName, PreferenceTypeDescription, PreferenceTypeDefaultValue);

                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully created preference type");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }

            return Redirect("~/PreferenceType/List");
        }

        public async Task<IActionResult> OnPostRemovePreferenceType()
        {
            try
            {
                var adminMemberSid = HttpContext.Session.GetString(SessionKey.MemberSid);

                await _memberPreferenceTypeService.Delete(PreferenceTypeID);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully removed preference type");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }
          
            return Redirect("~/PreferenceType/List");
        }

        public async Task<IActionResult> OnPostUpdatePreferenceType()
        {
            try
            {
                var adminMemberSid = HttpContext.Session.GetString(SessionKey.MemberSid);

                var MemberAdmin = await _memberPreferenceTypeService.Update(PreferenceTypeID, PreferenceTypeName, PreferenceTypeDescription, PreferenceTypeDefaultValue);

                if (CurrentPreferenceTypeStatus != PreferenceTypeStatus)
                {
                    if (PreferenceTypeStatus == RecordStatus.Active)
                    {
                        await _memberPreferenceTypeService.Enable(PreferenceTypeID);
                    }
                    else
                    {
                        await _memberPreferenceTypeService.Disable(PreferenceTypeID);
                    }
                }

                HttpContext.Session.SetString(SessionKey.NotificationMessage.Sucess, "Successfully updated preference type");
            }
            catch (ArgumentException ex)
            {
                _logger.LogInformation(ex, ex.Message);
                HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)}");
            }
            catch (Exception ex)
            {
                if (ex is InvalidOperationException)
                {
                    _logger.LogInformation(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, $"{ExceptionExtensions.GetDescription(ex)} {ErrorMessage.ErrorMessagePostfix.ErrorDescription}");
                }
                else
                {
                    _logger.LogError(ex, ex.Message);
                    HttpContext.Session.SetString(SessionKey.NotificationMessage.Error, ErrorMessage.ErrorMessageDefault.ErrorDescription);
                }
            }
           
            return Redirect("~/PreferenceType/List");
        }

    }
}

BeamAndGo.Member.Admin.Web/Pages/PreferenceType/List.cshtml
@page
@model BeamAndGo.Member.Admin.Web.Pages.PreferenceType.PreferenceTypeListModel
@{
    ViewData["Title"] = "Preference Type List";
}

<style>
    .filter tr {
        cursor: pointer;
    }
</style>

<body>
    <div class="uk-container uk-container-center">
        <div class="uk-grid-small" uk-grid>
            <div class="uk-width-1-6@m uk-visible@m">
                @{
                    await Html.RenderPartialAsync("_Menu");
                }
            </div>

            <div class="uk-width-expand@m">
                <div class="uk-card uk-card-default uk-card-body">
                    <h3 class="uk-card-title">@ViewData["Title"]</h3>

                    <div uk-filter="target: .filter" class="uk-width-1-1 filter-main">
                        <table class="uk-table">
                            <tbody>
                                <tr>
                                    <td class="uk-text-nowrap uk-align-right">
                                        <button class="bng-modal uk-button uk-button-primary" uk-toggle="target: #modal-preferenceType-create">Add Preference Type</button>
                                    </td>
                                </tr>
                            </tbody>
                        </table>
                        <div class="uk-overflow-auto">
                            <table class="uk-table uk-table-hover uk-table-middle uk-table-divider">
                                <thead>
                                    <tr>
                                        <th class="uk-text-nowrap">Preference Type Name</th>
                                    </tr>
                                </thead>
                                <tbody id="table-body" class="filter">
                                    @foreach (var m in Model.MemberPreferenceTypes)
                                    {
                                        <tr>
                                            <td class="uk-text-nowrap uk-table-expand">@m.Name</td>
                                            <td class="uk-text-nowrap uk-width-small">
                                                <button class="member-preferenceType-edit uk-button"
                                                        uk-toggle="target: #modal-preferenceType-edit"
                                                        SelectedPreferenceTypeID="@m.Id"
                                                        SelectedPreferenceTypeName="@m.Name"
                                                        SelectedPreferenceTypeDescription="@m.Description"
                                                        SelectedPreferenceTypeDefaultValue="@m.DefaultValue"
                                                        SelectedAccessStatus="@m.RecordStatus">
                                                    <i class="fas fa-pencil-alt"></i>
                                                </button>
                                            </td>
                                            <td class="uk-text-nowrap uk-width-small">
                                                <button class="member-preferenceType-remove uk-button"
                                                        uk-toggle="target: #modal-preferenceType-remove"
                                                        SelectedPreferenceTypeID="@m.Id"
                                                        SelectedPreferenceTypeName="@m.Name">
                                                    <i class="fas fa-trash"></i>
                                                </button>
                                            </td>
                                        </tr>
                                    }
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</body>

<!-- This is the modal -->
<div id="modal-preferenceType-create" uk-modal class="uk-flex-top modal-preferenceType-create">
    <div class="uk-modal-dialog uk-margin-auto-vertical">
        <div class="uk-modal-body">
            <h3>Create Preference Type</h3>
            <div class="uk-card uk-card-default uk-card-small uk-card-body">
                <form method="post" asp-page-handler="CreatePreferenceType" asp-antiforgery="true">
                    <div class="uk-margin-small">
                        <label class="uk-form-label">Name </label>
                        <input class="uk-input" asp-for="@Model.PreferenceTypeName" type="text">
                    </div>
                    <div class="uk-margin-small">
                        <label class="uk-form-label">Description </label>
                        <textarea asp-for="PreferenceTypeDescription" class="uk-textarea" rows="3" type="text" maxlength="128"></textarea>
                    </div>
                    <div class="uk-margin-small uk-margin-medium-bottom">
                        <label class="uk-form-label">Default Value</label>
                        <input class="uk-input" asp-for="@Model.PreferenceTypeDefaultValue" type="text" placeholder="true or false">
                    </div>
                    <div class="uk-margin-small">
                        <button class="uk-button uk-button-primary uk-width-1-1" type="submit">Add</button>
                    </div>
                    <div class="uk-margin-small">
                        <button class="uk-button uk-button-default uk-width-1-1 uk-modal-close" type="button">Cancel</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
<!-- End of modal -->
<!-- This is the modal -->
<div id="modal-preferenceType-edit" uk-modal class="uk-flex-top modal-preferenceType-edit">
    <div class="uk-modal-dialog uk-margin-auto-vertical">
        <div class="uk-modal-body">
            <h3>Update Preference Type</h3>
            <div class="uk-card uk-card-default uk-card-small uk-card-body">
                <form method="post" asp-page-handler="UpdatePreferenceType" asp-antiforgery="true">
                    <input class="member-preferenceType-current-status-input" asp-for="@Model.CurrentPreferenceTypeStatus" type="hidden" />
                    <input class="member-preferenceType-edit-input" asp-for="@Model.PreferenceTypeID" type="hidden">
                    <div class="uk-margin-small">
                        <label class="uk-form-label">Name </label>
                        <input class="edit-preferenceType-name uk-input" asp-for="@Model.PreferenceTypeName" type="text">
                    </div>
                    <div class="uk-margin-small">
                        <label class="uk-form-label">Description </label>
                        <textarea asp-for="PreferenceTypeDescription" class="uk-textarea edit-preferenceType-desc" rows="3" type="text" maxlength="128"></textarea>
                    </div>
                    <div class="uk-margin-small">
                        <label class="uk-form-label">Default Value</label>
                        <input class="uk-input edit-preferenceType-default-value" asp-for="@Model.PreferenceTypeDefaultValue" type="text">
                    </div>
                    <div class="uk-margin-small uk-margin-medium-bottom">
                        <label class="uk-form-label">Record Status</label>
                        <div>
                            @foreach (var accessStatus in System.Enum.GetValues(typeof(BeamAndGo.Core.Data.RecordStatus)).OfType<BeamAndGo.Core.Data.RecordStatus>())
                            {
                                <label><input class="uk-radio" id="Record_@accessStatus" type="radio" asp-for="PreferenceTypeStatus" value="@accessStatus" /><span style="padding-right: 5px;"></span>@accessStatus<span style="padding-right: 10px;"></span></label>
                            }
                        </div>
                    </div>
                    <div class="uk-margin-small">
                        <button class="uk-button uk-button-primary uk-width-1-1" type="submit">Update</button>
                    </div>
                    <div class="uk-margin-small">
                        <button class="uk-button uk-button-default uk-width-1-1 uk-modal-close" type="button">Cancel</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
<!-- End of modal -->
<!-- This is the modal -->
<div id="modal-preferenceType-remove" uk-modal class="uk-flex-top modal-preferenceType-remove">
    <div class="uk-modal-dialog uk-margin-auto-vertical">
        <div class="uk-modal-body uk-text-center">
            <p> Are you sure you want to delete <i><span class="remove-preferenceType">beamandgo</span></i>?</p>
            <form method="post" asp-page-handler="removePreferenceType" asp-antiforgery="true">
                <input type="hidden" asp-for="@Model.PreferenceTypeID" id="remove-preferenceType-selected" class="member-preferenceType-remove-input" />
                <button class="uk-button uk-button-primary" type="submit">Ok</button>
                <button class="uk-button uk-button-default uk-modal-close" type="button">Cancel</button>
            </form>
        </div>
    </div>
</div>
<!-- End of modal -->
<script>
    $(document).ready(function () {
    });

    $('.member-preferenceType-edit').click(function () {
        $('.member-preferenceType-current-status-input').val($(this).attr('SelectedAccessStatus'));
        $('.member-preferenceType-edit-input').val($(this).attr('SelectedPreferenceTypeID'));

        $('.edit-preferenceType-name').val($(this).attr('SelectedPreferenceTypeName'));
        $('.edit-preferenceType-desc').val($(this).attr('SelectedPreferenceTypeDescription'));
        $('.edit-preferenceType-default-value').val($(this).attr('SelectedPreferenceTypeDefaultValue'));

        $("#Record_" + $(this).attr('SelectedAccessStatus')).attr("checked", "checked");
    });

    $('.member-preferenceType-remove').click(function () {
        $('.remove-preferenceType').text($(this).attr('SelectedPreferenceTypeName'));
        $('.member-preferenceType-remove-input').val($(this).attr('SelectedPreferenceTypeID'));
    });
</script>